#include "Vector.h"
#include <iostream>
int main()
{
    using namespace std;
    try
    {
        cout << "constructor" << endl;
        Vector vec1(2, 5);
        cout << vec1 << endl << endl;
        //
        cout << "operation = " << endl;
        Vector vec2(3, 6);
        cout << "vec1 =" << vec1 << endl;
        cout << "vec2 =" << vec2 << endl;
        vec1 = vec2;
        cout << "vec1=vec2 -> vec1 =" << vec1 << endl << endl;
        //
        cout << "operation += " << endl;
        Vector vec3(3, 8.4);
        cout << "vec1 =" << vec1 << endl;
        cout << "vec3 =" << vec3 << endl;
        vec1 += vec3;
        cout << "vec1+=vec3 =" << vec1 << endl << endl;
        //
        cout << "operation -= " << endl;
        cout << "vec2 =" << vec2 << endl;
        cout << "vec3 =" << vec3 << endl;
        vec2 -= vec3;
        cout << "vec2-=vec3 =" << vec2 << endl << endl;
        //
        cout << "unary - " << endl;
        Vector vec4 = -vec1;
        cout << "vec1 =" << vec1 << endl;
        cout << "vec4= -vec1 -> vec4 =" << vec4 << endl << endl;
        //
        cout << "unary + " << endl;
        Vector vec5 = +vec4;
        cout << "vec4 =" << vec1 << endl;
        cout << "vec5= +vec4 -> vec5 =" << vec4 << endl << endl;
        //
        cout << "binary - " << endl;
        cout << "vec1 =" << vec1 << endl;
        cout << "vec2 =" << vec2 << endl;
        cout << "vec1 - vec2 =" << vec1 - vec2 << endl << endl;
        //
        cout << "binary + " << endl;
        cout << "vec1 =" << vec1 << endl;
        cout << "vec2 =" << vec2 << endl;
        cout << "vec1 + vec2 =" << vec1 + vec2 << endl << endl;
        //
        cout << "multiplication a vector by a number" << endl;
        double number = 3;
        cout << "vec1 =" << vec1 << endl;
        cout << "scalar =" << number << endl;
        cout << "vec1 *scalar  =" << vec1 * number << endl << endl;
        //
        cout << "multiplication a number by a vector" << endl;
        number = 5;
        cout << "vec1 =" << vec1 << endl;
        cout << "scalar =" << number << endl;
        cout << "scalar * vec1 =" << number * vec1 << endl << endl;
        //
        cout << "dot product of vectors" << endl;
        cout << "vec1 =" << vec1 << endl;
        cout << "vec2 =" << vec2 << endl;
        cout << "vec1*vec2 =" << vec1 * vec2 << endl << endl;
        //
        cout << "input of vector and vector pointer" << endl;
        cin >> vec1;
        cout << "vec1 =" << vec1 << endl;
        double* ptr = vec1;
        cout << "vec1 pointer is " << ptr << endl << endl;
        //
        cout << "separate element of vector" << endl;
        cout << "vec1 =" << vec1 << endl;
        cout << "2nd element of vec1 is " << vec1[1] << endl << endl;
        //
        cout << "method of vector dimension" << endl;
        cout << "vec1 =" << vec1 << endl;
        cout << "vec1 dimension is " << vec1.dimension() << endl << endl;
        //
        cout << "method of vector lenghth" << endl;
        cout << "vec1 =" << vec1 << endl;
        cout << "vec1 lenghth is " << vec1.length() << endl << endl;
        //    
        double* v1 = new double[7];
        v1[0] = 9;
        v1[1] = 11;
        v1[2] = 10;
        v1[3] = 9;
        v1[4] = 12;
        v1[5] = 8;
        v1[6] = 8;
        Vector vector(7, 5);
        double* v2 = new double[9];
        v2[0] = 1;
        v2[1] = 2;
        v2[2] = 1;
        v2[3] = 2;
        v2[4] = 1;
        v2[5] = 1;
        v2[6] = 2;
        v2[7] = 2;
        v2[8] = 3;
        size_t* v3 = new size_t[9];
        v3[0] = 2;
        v3[1] = 1;
        v3[2] = 2;
        v3[3] = 3;
        v3[4] = 1;
        v3[5] = 4;
        v3[6] = 1;
        v3[7] = 2;
        v3[8] = 5;
        size_t* v4 = new size_t[8];
        v4[0] = 1;
        v4[1] = 1;
        v4[2] = 1;
        v4[3] = 2;
        v4[4] = 5;
        v4[5] = 7;
        v4[6] = 7;
        v4[7] = 10;
        size_t a = 7;
        size_t b = 9;
        CSLRMatrix mat1(v1, v2, v3, v4, a, b);

        cout << "mat1:" << endl;
        cout << mat1 << endl;
        //  
        cout << "multiplication a matrix by a number" << endl;
        number = 3;
        cout << "scalar =" << number << endl;

        cout << "mat1 *scalar  =\n" << mat1 * number << endl << endl;
        //
        cout << "multiplication a number by a matrix" << endl;
        number = 5;
        cout << "scalar =" << number << endl;
        cout << "scalar * mat1 =\n" << number * mat1 << endl << endl;
        //
        cout << "multiplication a matrix by a vector" << endl;
        cout << "vector =" << vector << endl;
        cout << "vector * mat1 = " << mat1 * vector << endl << endl;
        //
        double* ve1 = new double[4];
        ve1[0] = 1;
        ve1[1] = 2;
        ve1[2] = 3;
        ve1[3] = 4;
        double* ve2 = new double[2];
        ve2[0] = 2;
        ve2[1] = 5;
        size_t* ve3 = new size_t[2];
        ve3[0] = 1;
        ve3[1] = 2;
        size_t* ve4 = new size_t[5];
        ve4[0] = 1;
        ve4[1] = 1;
        ve4[2] = 1;
        ve4[3] = 1;
        ve4[4] = 3;
        size_t c = 4;
        size_t d = 2;
        CSLRMatrix mat2(ve1, ve2, ve3, ve4, c, d);
        cout << "operation = " << endl;
        cout << "mat1 =\n" << mat1 << endl;
        cout << "mat2 =\n" << mat2 << endl;
        mat2 = mat1;
        cout << "mat2=mat1 -> mat2 =\n" << mat2 << endl << endl;
        //
        cout << "method of matrix size" << endl;
        cout << "mat1 dimension is " << mat1.matsize() << endl << endl;
        //
        cout << "method of matrix's non-zero elements" << endl;
        cout << "number of mat1 non-zero elements is " << mat1.nzn() << endl << endl;
        //
        //
        cout << "final test" << endl;
        Vector vec(7, 0);
        vec[0] = 1;
        vec[1] = 2;
        vec[2] = 3;
        vec[3] = 4;
        vec[4] = 5;
        vec[5] = 6;
        vec[6] = 7;
        Vector result(vec);
        cout << "vector1 =" << vec << endl;
        Vector vect(7, 0);
        vect[0] = 14;
        vect[1] = 6;
        vect[2] = 2;
        vect[3] = 11;
        vect[4] = 3;
        vect[5] = 3;
        vect[6] = 1;
        cout << "vector2 =" << vect << endl;
        Vector vecto(7, 0);
        vecto[0] = 5;
        vecto[1] = 6;
        vecto[2] = 4;
        vecto[3] = 19;
        vecto[4] = 6;
        vecto[5] = 20;
        vecto[6] = 5;
        cout << "vector3 =" << vecto << endl;
        int k1 = 4;
        cout << "number1 =" << a << endl;
        int k2 = 10;
        cout << "number2 =" << b << endl;
        int k3 = 10;
        cout << "number3 =" << c << endl;
        cout << "matrix =" << endl << mat1 << endl;
        result = -k1 * mat1 * (vec - k2 * vect) + vecto * k3;
        cout << " result = -number1 * matrix * (vector1 - number2 * vector2) + vector3 * number3" << endl << result << endl;
        delete[] v1;
        delete[] v2;
        delete[] v3;
        delete[] v4;
        delete[] ve1;
        delete[] ve2;
        delete[] ve3;
        delete[] ve4;
    }   
    catch (OutOfRangeException& exception)
    {
        std::cout << exception.what();
    }
    catch (IncompatibleDimException& exception)
    {
        std::cout << exception.what();
    }
    return 0;
}